diff --git a/game/client/build.gradle.kts b/game/client/build.gradle.kts
index 75d30edb7..faee365fa 100644
--- a/game/client/build.gradle.kts
+++ b/game/client/build.gradle.kts
@@ -48,9 +48,11 @@ dependencies {
     implementation(libs.gson)?.let { include(it) }
     implementation(libs.brigadier)?.let { include(it) }
     implementation(libs.bundles.log4j)?.let { include(it) }
+    implementation(project(":util:nbt"))?.let { include(it) }
+    implementation(project(":util:logging"))?.let { include(it) }
     // </core dependencies>
 
-    implementation("legacy-lwjgl3:legacy-lwjgl3:1.0.1")?.let { include(it) }
+    implementation("legacy-lwjgl3:legacy-lwjgl3:1.0.3")?.let { include(it) }
 
     implementation(libs.bundles.lwjgl)
     for (lib in libs.bundles.lwjgl.get()) {
diff --git a/game/client/src/main/java/net/betterthanadventure/utils/ResetBiomes.java b/game/client/src/main/java/net/betterthanadventure/utils/ResetBiomes.java
index 8be877107..6e68623f5 100644
--- a/game/client/src/main/java/net/betterthanadventure/utils/ResetBiomes.java
+++ b/game/client/src/main/java/net/betterthanadventure/utils/ResetBiomes.java
@@ -8,9 +8,9 @@ import java.util.List;
 import java.util.Map;
 
 import com.mojang.logging.LogUtils;
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.NbtIo;
-import com.mojang.nbt.Tag;
+import com.mojang.nbt.tags.Tag;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.world.ProgressListener;
diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index ff7e67aad..1a2d32c65 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -13,7 +13,7 @@ import java.net.URL;
 import java.util.*;
 
 import com.mojang.logging.LogUtils;
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.client.entity.ClientSkinVariantList;
 import net.minecraft.client.entity.player.PlayerLocal;
 import net.minecraft.client.gui.*;
diff --git a/game/client/src/main/java/net/minecraft/client/entity/particle/Particle.java b/game/client/src/main/java/net/minecraft/client/entity/particle/Particle.java
index 4b9a0c36f..1264405f7 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/particle/Particle.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/particle/Particle.java
@@ -6,7 +6,7 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.MathHelper;
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.world.World;
 
 /**
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
index 06ef3e025..01899d60b 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
@@ -2,7 +2,7 @@ package net.minecraft.client.entity.player;
 
 import com.mojang.brigadier.exceptions.CommandSyntaxException;
 import com.mojang.logging.LogUtils;
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.particle.ParticlePickupAnimation;
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerRemote.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerRemote.java
index 05400c3d4..73a8e8ae9 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerRemote.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerRemote.java
@@ -4,7 +4,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.world.World;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.GetSkinUrlThread;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java b/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
index bc12a1438..ff44062bb 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
@@ -16,7 +16,7 @@ import net.minecraft.client.gui.guidebook.SlotGuidebook;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 
 public class TooltipElement extends Gui
 {
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 84e6d65ad..ddcf6c90a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -881,7 +881,7 @@ public class RenderGlobal
 
         // Render sun
         float size = 30F;
-        textureManager.loadTexture("/terrain/sun.png").bind();
+        textureManager.loadTexture("/assets/minecraft/textures/terrain/sun.png").bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, sunAlpha);
         t.startDrawingQuads();
         t.addVertexWithUV(-size, 100D, -size, 0.0D, 0.0D);
@@ -938,7 +938,7 @@ public class RenderGlobal
             rainbowBrightness += rainbowBrightnessDelta * partialTick;
 
             // Draws and colors ring textures to make the rainbow
-            textureManager.loadTexture("/terrain/rainbow.png").bind();
+            textureManager.loadTexture("/assets/minecraft/textures/terrain/rainbow.png").bind();
             t.startDrawingQuads();
             final int iterations = 10;
             for (int i = 0; i < iterations; i++) {
@@ -963,7 +963,7 @@ public class RenderGlobal
 
         // Render moon
         size = 20F;
-        textureManager.loadTexture("/terrain/moon.png").bind();
+        textureManager.loadTexture("/assets/minecraft/textures/terrain/moon.png").bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, sunAlpha);
         t.startDrawingQuads();
         t.addVertexWithUV(-size, -100D, size, 1.0D, 1.0D);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
index 254d2dc36..d4caf3503 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
@@ -10,6 +11,7 @@ import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.Nullable;
+import org.lwjgl.opengl.GL11;
 
 public class BlockModelPumice<T extends BlockLogic> extends BlockModelStandard<T> {
     private boolean lavaFlag = false;
@@ -34,10 +36,24 @@ public class BlockModelPumice<T extends BlockLogic> extends BlockModelStandard<T
 
     @Override
     public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+        if(renderBlocks.useInventoryTint) {
+            int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
+            float r = (float) (color >> 16 & 0xff) / 255F;
+            float g = (float) (color >> 8 & 0xff) / 255F;
+            float b = (float) (color & 0xff) / 255F;
+            GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
+        }else {
+            GL11.glColor4f(brightness, brightness, brightness, alpha);
+        }
+        float yOffset = 0.5F;
+
+        GL11.glTranslatef(-0.5F, 0.0F - yOffset, -0.5F);
+
         lavaFlag = true;
         boolean ob = renderBlocks.overbright;
         renderBlocks.overbright = true;
-        AABB bounds = AABB.getTemporaryBB(0.005, 0.005, 0.005, 0.995, 0.995, 0.995);
+        final double depthFixOffset = 0.001d;
+        AABB bounds = AABB.getTemporaryBB(depthFixOffset, depthFixOffset, depthFixOffset, 1 - depthFixOffset, 1 - depthFixOffset, 1 - depthFixOffset);
         renderBlockWithBounds(tessellator, bounds, metadata, brightness, alpha, LightmapHelper.getLightmapCoord(15, 15));
 
         renderBlocks.overbright = ob;
@@ -47,6 +63,8 @@ public class BlockModelPumice<T extends BlockLogic> extends BlockModelStandard<T
         }
         bounds.set(0, 0, 0, 1, 1, 1);
         renderBlockWithBounds(tessellator, bounds, metadata, brightness, alpha, lightmapCoordinate);
+
+        GL11.glTranslatef(0.5F, yOffset, 0.5F);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
index fc54fdee1..fe24d1e57 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
@@ -94,10 +94,10 @@ public class MobRenderer<T extends Mob> extends EntityRenderer<T>
             }
 
             renderAdditional(entity, partialTick);
-            float f9 = entity.getBrightness(partialTick);
-            if (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) f9 = 1.0f;
-            int j = getOverlayColor(entity, f9, partialTick);
-            if((j >> 24 & 0xff) > 0 || entity.hurtTime > 0 || entity.deathTime > 0)
+            float brightness = entity.getBrightness(partialTick);
+            if (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) brightness = 1.0f;
+            int argb = getOverlayColor(entity, brightness, partialTick);
+            if((argb >> 24 & 0xff) > 0 || entity.hurtTime > 0 || entity.deathTime > 0)
             {
                 GL11.glDisable(GL11.GL_TEXTURE_2D);
                 GL11.glDisable(GL11.GL_ALPHA_TEST);
@@ -106,33 +106,33 @@ public class MobRenderer<T extends Mob> extends EntityRenderer<T>
                 GL11.glDepthFunc(514);
                 if(entity.hurtTime > 0 || entity.deathTime > 0)
                 {
-                    GL11.glColor4f(f9, 0.0F, 0.0F, 0.4F);
+                    GL11.glColor4f(brightness, 0.0F, 0.0F, 0.4F);
                     mainModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
                     if (overlayModel != null) overlayModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
                     for(int k = 0; k < MAX_ARMOR_LAYERS; k++)
                     {
                         if(prepareArmor(entity, k, partialTick))
                         {
-                            GL11.glColor4f(f9, 0.0F, 0.0F, 0.4F);
+                            GL11.glColor4f(brightness, 0.0F, 0.0F, 0.4F);
                             armorModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
                         }
                     }
 
                 }
-                if((j >> 24 & 0xff) > 0)
+                if((argb >> 24 & 0xff) > 0)
                 {
-                    float f10 = (float)(j >> 16 & 0xff) / 255F;
-                    float f11 = (float)(j >> 8 & 0xff) / 255F;
-                    float f12 = (float)(j & 0xff) / 255F;
-                    float f13 = (float)(j >> 24 & 0xff) / 255F;
-                    GL11.glColor4f(f10, f11, f12, f13);
+                    float r = (float)(argb >> 16 & 0xff) / 255F;
+                    float g = (float)(argb >> 8 & 0xff) / 255F;
+                    float b = (float)(argb & 0xff) / 255F;
+                    float a = (float)(argb >> 24 & 0xff) / 255F;
+                    GL11.glColor4f(r, g, b, a);
                     mainModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
                     if (overlayModel != null) overlayModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
                     for(int l = 0; l < MAX_ARMOR_LAYERS; l++)
                     {
                         if(prepareArmor(entity, l, partialTick))
                         {
-                            GL11.glColor4f(f10, f11, f12, f13);
+                            GL11.glColor4f(r, g, b, a);
                             armorModel.render(walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale);
                         }
                     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererGhast.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererGhast.java
index 353906b40..93335d9d6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererGhast.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererGhast.java
@@ -32,6 +32,5 @@ public class MobRendererGhast extends MobRenderer<MobGhast>
         float f2 = (8F + charge) / 2.0F;
         float f3 = (8F + 1.0F / charge) / 2.0F;
         GL11.glScalef(f3, f2, f3);
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
index 097660555..da22957f8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
@@ -6,6 +6,7 @@ import net.minecraft.client.entity.player.PlayerLocal;
 import net.minecraft.client.render.BlockEntityRenderDispatcher;
 import net.minecraft.client.render.Font;
 import net.minecraft.client.render.Lighting;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.PlayerSkinParser;
 import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.block.model.BlockModel;
@@ -18,6 +19,7 @@ import net.minecraft.client.render.model.ModelPlayer;
 import net.minecraft.client.render.model.ModelPlayerSlim;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.Global;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.motion.CarriedBlock;
@@ -87,7 +89,8 @@ public class MobRendererPlayer extends MobRenderer<Player>
     	
     	if(renderCape) {
             GL11.glPushMatrix();
-            GL11.glColor4f(1f, 1f, 1f, 1f);
+            float brightness = (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) ? 1 : player.getBrightness(partialTick);
+            GL11.glColor4f(brightness, brightness, brightness, 1f);
             GL11.glTranslatef(0.0F, 0.0F, 0.125F);
             float yawOff = player.yBodyRotO + (player.yBodyRot - player.yBodyRotO) * partialTick;
             float bodyAngle = 5;
diff --git a/game/client/src/main/java/net/minecraft/client/render/model/ModelBiped.java b/game/client/src/main/java/net/minecraft/client/render/model/ModelBiped.java
index eafc96b12..ac7602a22 100644
--- a/game/client/src/main/java/net/minecraft/client/render/model/ModelBiped.java
+++ b/game/client/src/main/java/net/minecraft/client/render/model/ModelBiped.java
@@ -142,7 +142,11 @@ public class ModelBiped extends ModelBase
             legRight.xRot -= 0.0F;
             legLeft.xRot -= 0.0F;
             armRight.xRot += 0.4F;
-            armLeft.xRot += 0.4F;
+//            armLeft.xRot += 0.4F;
+            if (holdingLarge) {
+                armRight.xRot -= 0.4f;
+                armLeft.xRot -= 0.5f;
+            }
             legRight.z = 4F;
             legLeft.z = 4F;
             legRight.y = 9F;
diff --git a/game/client/src/main/java/net/minecraft/client/world/save/SaveHandlerClientMP.java b/game/client/src/main/java/net/minecraft/client/world/save/SaveHandlerClientMP.java
index 38a3d9e87..ad4411534 100644
--- a/game/client/src/main/java/net/minecraft/client/world/save/SaveHandlerClientMP.java
+++ b/game/client/src/main/java/net/minecraft/client/world/save/SaveHandlerClientMP.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.world.save;
 
 import net.minecraft.core.entity.player.Player;
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.world.chunk.IChunkLoader;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.save.DimensionData;
diff --git a/game/core/build.gradle.kts b/game/core/build.gradle.kts
index a206ea0dc..3b8b424c3 100644
--- a/game/core/build.gradle.kts
+++ b/game/core/build.gradle.kts
@@ -34,7 +34,10 @@ dependencies {
     implementation(libs.gson)
     implementation(libs.brigadier)
     implementation(libs.bundles.log4j)
+    implementation(project(":util:nbt"))
+    implementation(project(":util:logging"))
     // </core dependencies>
+
 }
 
 java {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
index a6c5498cd..5bcae9e0e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
@@ -7,7 +7,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
index b14e07bd4..2c79ee608 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
@@ -17,6 +17,13 @@ public class BlockLogicLamp extends BlockLogic implements IPainted {
         isActive = isActivated;
     }
 
+    @Override
+    public void onBlockPlacedByWorld(World world, int x, int y, int z) {
+        if (isActive && !(world.hasDirectSignal(x, y, z) || world.hasNeighborSignal(x, y, z))) {
+            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_IDLE.id(), world.getBlockMetadata(x, y, z));
+        }
+    }
+
     @Override
     public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
         if (world.isClientSide) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
index e5ba5926a..4d016bb11 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
@@ -35,10 +35,14 @@ public class BlockLogicSlab extends BlockLogic
     	super(block, Material.stone);
         this.modelBlock = modelBlock;
         this.modelBlockMetadata = modelBlockMetadata;
+        block.withLightBlock(1);
+    }
+
+    @Override
+    public void initializeBlock() {
         block.withHardness(modelBlock.blockHardness);
         block.withBlastResistance(modelBlock.blastResistance / 3F);
         block.withLightEmission(modelBlock.emission);
-        block.withLightBlock(1);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
index d17029996..32974dc56 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
@@ -88,11 +88,15 @@ public class BlockLogicStairs extends BlockLogic
     {
         super(block, Material.stone);
         this.modelBlock = modelBlock;
-        block.withHardness(block.blockHardness);
-        block.withBlastResistance(block.blastResistance / 3F);
         block.withLightBlock(255);
     }
 
+    @Override
+    public void initializeBlock() {
+        block.withHardness(modelBlock.blockHardness);
+        block.withBlastResistance(modelBlock.blastResistance / 3F);
+    }
+
     @Override
     public @NotNull Material getMaterial() {
         return modelBlock.getMaterial();
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
index 16ffaba39..39c94be5b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block.entity;
 
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.tag.BlockTags;
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
index 9f35209bb..38bd36bb4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block.entity;
 
-import com.mojang.nbt.CompoundTag;
-import com.mojang.nbt.ListTag;
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.ListTag;
 import net.minecraft.core.block.BlockLogicRotatable;
 import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.block.Block;
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
index 7f4698c60..1df720942 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
@@ -8,8 +8,8 @@ import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
-import com.mojang.nbt.CompoundTag;
-import com.mojang.nbt.ListTag;
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.ListTag;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.PacketBlockEntityData;
 import net.minecraft.core.util.phys.AABB;
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
index 441ee6897..8c8ab54a9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
@@ -9,8 +9,8 @@ import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
-import com.mojang.nbt.CompoundTag;
-import com.mojang.nbt.ListTag;
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.ListTag;
 import net.minecraft.core.player.inventory.InventorySorter;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
index e968923ec..1ee070d85 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispatcher.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block.entity;
 
 import com.mojang.logging.LogUtils;
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.block.piston.TileEntityMovingPistonBlock;
 import net.minecraft.core.util.collection.NamespaceID;
 import org.slf4j.Logger;
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
index 72aaac246..1be08e68e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
@@ -9,8 +9,8 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.IDispensable;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
-import com.mojang.nbt.CompoundTag;
-import com.mojang.nbt.ListTag;
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.ListTag;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
index 74407bb7f..62f1c4983 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
@@ -3,8 +3,8 @@ package net.minecraft.core.block.entity;
 import java.util.Random;
 import java.util.UUID;
 
-import com.mojang.nbt.CompoundTag;
-import com.mojang.nbt.ListTag;
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.ListTag;
 
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Items;
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java
index 2c6399051..e1d943d51 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block.entity;
 
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicFlowerStackable;
 import net.minecraft.core.block.Blocks;
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
index 1976b97d5..5bae21bdc 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block.entity;
 
-import com.mojang.nbt.CompoundTag;
-import com.mojang.nbt.ListTag;
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.ListTag;
 import net.minecraft.core.block.BlockLogicFurnace;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.motion.CarriedBlock;
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
index 6bf07adcb..7fec79f08 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block.entity;
 
-import com.mojang.nbt.CompoundTag;
-import com.mojang.nbt.ListTag;
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.ListTag;
 import net.minecraft.core.block.BlockLogicFurnaceBlast;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.crafting.LookupFuelFurnaceBlast;
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java
index 001f3f73c..899b505d3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityJukebox.java
@@ -6,7 +6,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.save.conversion.ChunkConverter;
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 
 public class TileEntityJukebox extends TileEntity {
     public int record;
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
index 59703abee..bb153de03 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block.entity;
 
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
index 09c956409..ff1e5da00 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
@@ -5,7 +5,7 @@ import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.phys.AABB;
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.PacketSetMobSpawner;
 import org.slf4j.Logger;
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityNoteblock.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityNoteblock.java
index 342f815df..df4e9b66d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityNoteblock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityNoteblock.java
@@ -2,7 +2,7 @@ package net.minecraft.core.block.entity;
 
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.BlockLogicNote;
-import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.util.helper.MathHelper;
 
 @Deprecated
